<template>
  <form @submit.prevent="submitForm" method="post">
    <el-dialog
      title="เพิ่มปีงบประมาณ"
      v-model="openDialog"
      width="350px"
      :before-close="handleClose"
    >
      <div class="grid">
        <p>ปีงบประมาณ</p>
        <input
          :class="`${errors.year ? ' border-red-600' : ''}
                  px-3
                  py-2
                  rounded
                  border border-gray-200
                  placeholder-gray-300`"
          v-model="formBudjetYear.year"
          placeholder="ปีงบประมาณ"
        />
        <small class="text-red-500 font-bold">{{ errors?.year }} </small>
      </div>
      <template #footer>
        <span class="dialog-footer">
          <button
            @click="handleClose"
            class="
              transition
              duration-200
              ease-in-out
              transform
              hover:-translate-y-1
              px-3
              py-1
              bg-gradient-to-r
              from-red-600
              to-red-400
              rounded-md
              text-white
              shadow-md
              mr-2
              focus:outline-none
            "
            type="button"
          >
            ยกเลิก
          </button>
          <button
            type="submit"
            class="
              transition
              duration-200
              ease-in-out
              transform
              hover:-translate-y-1
              px-3
              py-1
              bg-gradient-to-r
              from-blue-600
              to-green-400
              rounded-md
              text-white
              shadow-md
              focus:outline-none
            "
          >
            เพิ่ม
          </button>
        </span>
      </template>
    </el-dialog>
  </form>
</template>

<script>
import { Inertia } from "@inertiajs/inertia";
import { defineComponent, reactive, ref, toRefs, watch } from "vue";

export default defineComponent({
  props: {
    open: {
      type: Boolean,
      required: true,
    },
  },
  setup(props, { emit }) {
    //   model
    const { open } = toRefs(props);
    const openDialog = ref(false);
    watch(open, (value, prevValue) => {
      openDialog.value = value;
      console.log(value);
    });
    // form

    const formBudjetYear = reactive({
      year: null,
    });
    const errors = reactive({
      year: null,
    });
    const submitForm = () => {
      Inertia.post(route("admin.years.store"), formBudjetYear, {
        onError: (err) => (errors.year = err.year),
        onSuccess: () => handleClose(),
      });
    };

    const handleClose = () => {
      emit("close");
      openDialog.value = false;
      formBudjetYear.year = null;
      errors.year = null;
    };
    return {
      openDialog,
      handleClose,
      submitForm,
      formBudjetYear,
      errors,
    };
  },
});
</script>
